package org.spagic.workflow.api.jbpm;

import org.jbpm.graph.exe.ExecutionContext;
import org.jbpm.graph.exe.Token;

public class TokenContext {

	private Long rootTokenId = null;
	private Long tokenId = null;
	
	
	public Long getTokenId() {
		return tokenId;
	}

	public Long getRootTokenId() {
		return rootTokenId;
	}
	
	public TokenContext(Long rootTokenId){
		this(rootTokenId, rootTokenId);
	}
	
	public TokenContext(Long rootTokenId, Long tokenId){
		this.rootTokenId = rootTokenId;
		this.tokenId = tokenId;
	}
	
	public String toString(){
		StringBuffer tokenContext = new StringBuffer();
		tokenContext.append(String.valueOf(rootTokenId));
		if (tokenId != null){
			tokenContext.append("," + String.valueOf(tokenId));
		}
		return tokenContext.toString();
	}
	
	public static TokenContext fromTokenContex(String tokenContext){
		if (tokenContext.indexOf(",") > 0){
			String[] tokens  = tokenContext.split(",");
			return new TokenContext(Long.valueOf(tokens[0]), Long.valueOf(tokens[1]));
		}else{
			return new TokenContext(Long.valueOf(tokenContext));
		}
	}
	
	public static TokenContext fromExecutionContext(ExecutionContext executionContext){
		Token token = executionContext.getToken();
		if (token.isRoot())
			return new TokenContext(token.getId());
		else{
			return new TokenContext(executionContext.getProcessInstance().getRootToken().getId(), token.getId());
		}
	}
	
	

}
