/**

    Copyright 2007, 2009 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.workflow.command;

import java.util.HashMap;
import java.util.Map;

import org.spagic.workflow.api.IControlExtendedAPI;

public class CMDControlExtendedAPI implements IControlExtendedAPI {

	private ICommandBasedProcessEngine engine = null;

	public CMDControlExtendedAPI(ICommandBasedProcessEngine engine) {
		this.engine =  engine;

	}	

	public boolean areNodesOnSameToken(long processInstanceId, String sourceTaskName, String destTaskName) {
		String method = CmdObject.ARE_NODES_ON_SAME_TOKEN;

		Map<String, Object> paramMap = new HashMap<String, Object>();
		paramMap.put("processInstanceId", processInstanceId);
		paramMap.put("sourceTaskName", sourceTaskName);
		paramMap.put("destTaskName", destTaskName);

		CmdObject cmdObject = new CmdObject(method, paramMap);
		ResultObject resultObject = (ResultObject) this.engine.executeCmdObject(cmdObject);

		return (Boolean) resultObject.getResult();
	}

	public void forceToken(long processInstanceId, String sourceTaskName, String destTaskName) {
		String method = CmdObject.FORCE_TOKEN_WITH_MULTIPLE_TOKENS;

		Map<String, Object> paramMap = new HashMap<String, Object>();
		paramMap.put("processInstanceId", processInstanceId);
		paramMap.put("sourceTaskName", sourceTaskName);
		paramMap.put("destTaskName", destTaskName);

		CmdObject cmdObject = new CmdObject(method, paramMap);
		this.engine.executeCmdObject(cmdObject);
	}

	public void forceToken(long processInstanceId, String destTaskName) {
		String method = CmdObject.FORCE_TOKEN_WITH_SINGLE_TOKEN;

		Map<String, Object> paramMap = new HashMap<String, Object>();
		paramMap.put("processInstanceId", processInstanceId);
		paramMap.put("destTaskName", destTaskName);

		CmdObject cmdObject = new CmdObject(method, paramMap);
		this.engine.executeCmdObject(cmdObject);
	}

}
