package org.spagic.workflow.handler;

import org.jbpm.graph.def.ActionHandler;
import org.jbpm.graph.exe.ExecutionContext;
import org.jbpm.graph.exe.ProcessInstance;
import org.spagic.workflow.handler.notifierproxy.NotifierProxy;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.Dom4JDriver;

public class NotifyHandler implements ActionHandler {
	public void execute(ExecutionContext executionContext) throws Exception {
		ProcessInstance processInstance = executionContext.getProcessInstance();
		XStream xStreamResObject = new XStream(new Dom4JDriver());
		String streamedObject = (String) executionContext.getVariable("_SPAGIC_NOTIFY_URL");
		NotifierProxy proxy = new NotifierProxy();
		if (streamedObject != null) {
			String url = (String) xStreamResObject.fromXML(streamedObject);
			proxy.setEndpoint(url);
		}
		long piid = processInstance.getId();
		String piName = processInstance.getProcessDefinition().getName();
		try {
			proxy.notify(piid, piName);
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
}
