package org.spagic.workflow.handler.notifierproxy;

public class NotifierProxy implements Notifier {
  private String _endpoint = null;
  private Notifier notifier = null;
  
  public NotifierProxy() {
    _initNotifierProxy();
  }
  
  public NotifierProxy(String endpoint) {
    _endpoint = endpoint;
    _initNotifierProxy();
  }
  
  private void _initNotifierProxy() {
    try {
      notifier = (new NotifierServiceLocator()).getNotifier();
      if (notifier != null) {
        if (_endpoint != null)
          ((javax.xml.rpc.Stub)notifier)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
        else
          _endpoint = (String)((javax.xml.rpc.Stub)notifier)._getProperty("javax.xml.rpc.service.endpoint.address");
      }
      
    }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (notifier != null)
      ((javax.xml.rpc.Stub)notifier)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public Notifier getNotifier() {
    if (notifier == null)
      _initNotifierProxy();
    return notifier;
  }
  
  public void notify(long processInstanceId, java.lang.String processName) throws java.rmi.RemoteException{
    if (notifier == null)
      _initNotifierProxy();
    notifier.notify(processInstanceId, processName);
  }
  
  
}